var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
document.addEventListener("deviceready", onDeviceReady, false);
window.gameWebServer.IsAudit = false;
window.onerror = handleError;
function handleError(msg, url, l, colno, error) {
    if (msg.indexOf("cordova/plugin_list/error") != -1) {
        return;
    }
    var errorLog = {};
    errorLog.msg = msg;
    errorLog.url = url;
    errorLog.line = l;
    errorLog.colno = colno;
    errorLog.stack = error.stack;
    errorLog.uid = platform.uid;
    PlatformCommon.log(platform, encodeURIComponent(JSON.stringify(errorLog)));
    setTimeout(function () {
        PlatformCommon.exit(msg);
    }, 2000);
    return false;
}
function onBackKeyDown(ev) {
    if (window.confirm('你确定要退出游戏吗？')) {
        navigator.app.exitApp();
        return true;
    }
    else {
        return false;
    }
}
function onDeviceReady() {
    return __awaiter(this, void 0, void 0, function () {
        function startPorgressBar() {
            if (window.gameWebServer.IsAudit) {
                var progressbarGif = document.getElementById("progressbarGifDiv");
                progressbarGif.style.display = "";
            }
            else {
                var logoDiv = document.getElementById("logoDiv");
                logoDiv.style.display = "";
                playPorgressBar(1.0, 12000);
            }
        }
        function playPorgressBar(progress, duration) {
            bar.animate(progress, { duration: duration }, function () {
                console.log("playPorgressBarComplete");
                bar.set(0);
                playPorgressBar(progress, duration);
            });
        }
        function xhrError() {
            if (window.confirm('网络异常，确认后重连！')) {
                window.location.reload();
                return true;
            }
            else {
                window.location.reload();
                return false;
            }
        }
        function xhrSend(url, callback, isAutoAlertError, method) {
            if (isAutoAlertError === void 0) { isAutoAlertError = true; }
            if (method === void 0) { method = "GET"; }
            var xhr = new XMLHttpRequest();
            xhr.open(method, url, true);
            xhr.addEventListener("load", function () {
                callback(xhr);
            });
            xhr.addEventListener('error', function () {
                console.log("error xhr url:" + url);
                if (isAutoAlertError) {
                    xhrError();
                }
                else {
                    callback(null);
                }
            }, false);
            xhr.send();
        }
        function loadVersion(versioncode, packagename) {
            return new Promise(function (resolve, reject) {
                var versionNum = parseInt(versioncode.split(".")[0]);
                packagename = encodeURIComponent(packagename);
                versioncode = encodeURIComponent(versioncode);
                var url = window.gameWebServer.host + "version?&channel=" + window.gameWebServer.channel + "&location=" + versionNum + "&packagename=" + packagename + "&versioncode=" + versioncode + "&openid=";
                xhrSend(url, function (xhr) {
                    if (xhr == null) {
                        resolve(xhr);
                        return;
                    }
                    var jsonObj = JSON.parse(xhr.response);
                    resolve(jsonObj);
                }, false);
            });
        }
        function loadSingleScript(src, callback) {
            return new Promise(function (resolve, reject) {
                var s = document.createElement('script');
                s.async = true;
                s.src = src;
                s.addEventListener('load', function () {
                    s.parentNode.removeChild(s);
                    s.removeEventListener('load', arguments.callee, false);
                    if (callback)
                        callback();
                    console.log("loadSingleScript:" + src);
                    resolve();
                }, false);
                s.addEventListener('error', function () {
                    xhrError();
                }, false);
                document.body.appendChild(s);
            });
        }
        function loadManifest(gameurl) {
            return new Promise(function (resolve, reject) {
                xhrSend(gameurl + 'manifest.json?v=' + (new Date()).getTime(), function (xhr) {
                    var manifest = JSON.parse(xhr.response);
                    if (manifest.gameVersion) {
                        window.gameVersion = manifest.gameVersion;
                    }
                    var gameList = [];
                    for (var i = 0; i < manifest.game.length; i++) {
                        var key = manifest.game[i];
                        if (key.indexOf("js/PfCommon_") != -1) {
                            continue;
                        }
                        if (key.indexOf("js/promise") != -1) {
                            continue;
                        }
                        gameList.push(key);
                    }
                    var list = manifest.initial.concat(gameList);
                    resolve(list);
                });
            });
        }
        function localFile(url) {
            return new Promise(function (resolve, reject) {
                var jsPath = cordova.file.applicationDirectory + '/www/' + url;
                window.resolveLocalFileSystemURL(jsPath, function (file) {
                    resolve(url);
                }, function () { resolve(window.gameClientHost + "/" + url); });
            });
        }
        function runEgret() {
            cordova.plugins.GSystemUtils.checkConnect("", function (res) { console.log("checkConnect: " + res); });
            /**
            * {
            * "renderMode":, //Engine rendering mode, "canvas" or "webgl"
            * "audioType": 0 //Use the audio type, 0: default, 2: web audio, 3: audio
            * "antialias": //Whether the anti-aliasing is enabled in WebGL mode, true: on, false: off, defaults to false
            * "calculateCanvasScaleFactor": //a function return canvas scale factor
            * }
            **/
            egret.runEgret({
                renderMode: "webgl", audioType: 0, calculateCanvasScaleFactor: function (context) {
                    var backingStore = context.backingStorePixelRatio ||
                        context.webkitBackingStorePixelRatio ||
                        context.mozBackingStorePixelRatio ||
                        context.msBackingStorePixelRatio ||
                        context.oBackingStorePixelRatio ||
                        context.backingStorePixelRatio || 1;
                    return (window.devicePixelRatio || 1) / backingStore;
                }
            });
            console.log("----runEgretSucceed----");
        }
        function run() {
            return __awaiter(this, void 0, void 0, function () {
                var packageName, versioncode, data, manifestList, i, jsPath;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (oneLoadErrorCount > 4) {
                                xhrError();
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, cordova.getAppVersion.getPackageName()];
                        case 1:
                            packageName = _a.sent();
                            return [4 /*yield*/, cordova.getAppVersion.getVersionNumber()];
                        case 2:
                            versioncode = _a.sent();
                            return [4 /*yield*/, loadVersion(versioncode, packageName)];
                        case 3:
                            data = _a.sent();
                            if (data == null) {
                                setTimeout(function () {
                                    run();
                                    oneLoadErrorCount++;
                                }, 2000);
                                return [2 /*return*/];
                            }
                            if (window.gameClientHost == "") {
                                window.gameClientHost = data.content.cdns;
                                if (data.content.cdns.indexOf("iosreview") !== -1) {
                                    window.gameWebServer.IsAudit = true;
                                }
                            }
                            if (window.gameClientHost.indexOf("baidu.com") != -1) {
                                window.gameClientHost = "https://yys37wan-runtime-test-1251923141.file.myqcloud.com/";
                            }
                            startPorgressBar();
                            return [4 /*yield*/, loadManifest(window.gameClientHost)];
                        case 4:
                            manifestList = _a.sent();
                            i = 0;
                            _a.label = 5;
                        case 5:
                            if (!(i < manifestList.length)) return [3 /*break*/, 9];
                            return [4 /*yield*/, localFile(manifestList[i])];
                        case 6:
                            jsPath = _a.sent();
                            return [4 /*yield*/, loadSingleScript(jsPath)];
                        case 7:
                            _a.sent();
                            _a.label = 8;
                        case 8:
                            i++;
                            return [3 /*break*/, 5];
                        case 9: return [4 /*yield*/, runEgret()];
                        case 10:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        }
        var bgimg, bar, oneLoadErrorCount;
        return __generator(this, function (_a) {
            if (StatusBar) {
                StatusBar.hide(); //隐藏顶部
            }
            setTimeout(function () {
                if (navigator.splashscreen) {
                    navigator.splashscreen.hide(); //隐藏启动页
                }
            }, 4000);
            document.addEventListener("backbutton", function (e) {
                cordova.exec(function () { console.log("open debug"); }, null, "GSystemUtils", "enabledWebDebug", []);
                cordova.plugins.USDK.onBackPressed(function (res) { console.log("Request Exit Succeed."); });
            }, false);
            bgimg = document.getElementById("bgimg");
            if (bgimg) {
                bgimg.style.display = "";
            }
            bar = new ProgressBar.Line(container, {
                strokeWidth: 4,
                easing: 'easeInOut',
                duration: 1400,
                color: '#FFEA82',
                trailColor: '#eee',
                trailWidth: 1,
                svgStyle: { width: '100%', height: '100%' },
                from: { color: '#FFEA82' },
                to: { color: '#ED6A5A' },
                step: function (state, bar) {
                    bar.path.setAttribute('stroke', state.color);
                }
            });
            window["closeLoadingView"] = function closeLoadingView() {
                bar.destroy();
                var bgimg = document.getElementById("bgimg");
                if (bgimg) {
                    bgimg.style.backgroundImage = "";
                    bgimg.remove();
                }
                var logoDiv = document.getElementById("logoDiv");
                if (logoDiv) {
                    logoDiv.remove();
                }
                var gifDiv = document.getElementById("progressbarGifDiv");
                if (gifDiv) {
                    gifDiv.remove();
                }
                var gif = document.getElementById("progressbarGif");
                if (gif) {
                    gif.remove();
                }
                delete window["closeLoadingView"];
            };
            ;
            oneLoadErrorCount = 0;
            run();
            return [2 /*return*/];
        });
    });
}
