document.addEventListener("deviceready", onDeviceReady, false);
window.gameWebServer.IsAudit = false;
window.onerror = handleError
function handleError(msg, url, l, colno, error) {
    if(msg.indexOf("cordova/plugin_list/error")!=-1){
        return;
    }
    var errorLog = {};
    errorLog.msg = msg;
    errorLog.url = url;
    errorLog.line = l;
    errorLog.colno = colno;
    errorLog.stack = error.stack;
    errorLog.uid = platform.uid;
    PlatformCommon.log(platform, encodeURIComponent(JSON.stringify(errorLog)));
    setTimeout(function () {
        PlatformCommon.exit(msg);
    }, 2000);
    return false;
}

function onBackKeyDown(ev) {
    if (window.confirm('你确定要退出游戏吗？')) {
        navigator.app.exitApp();
        return true;
    } else {
        return false;
    }
}

async function onDeviceReady() {
    if (StatusBar) {
        StatusBar.hide();//隐藏顶部
    }

    setTimeout(() => {
        if (navigator.splashscreen) {
            navigator.splashscreen.hide();//隐藏启动页
        }
    }, 4000);

    document.addEventListener("backbutton", e=>{
        cordova.exec(()=>{console.log("open debug")}, null, "GSystemUtils", "enabledWebDebug", []);
        cordova.plugins.USDK.onBackPressed(function (res) { console.log("Request Exit Succeed."); })
    }, false);

    var bgimg = document.getElementById("bgimg");
    if (bgimg) {
        bgimg.style.display = "";
    }

    var bar = new ProgressBar.Line(container, {
        strokeWidth: 4,
        easing: 'easeInOut',
        duration: 1400,
        color: '#FFEA82',
        trailColor: '#eee',
        trailWidth: 1,
        svgStyle: {width: '100%', height: '100%'},
        from: {color: '#FFEA82'},
        to: {color: '#ED6A5A'},
        step: (state, bar) => {
        bar.path.setAttribute('stroke', state.color);
        }
    });

    function startPorgressBar(){
        if(window.gameWebServer.IsAudit){
            var progressbarGif = document.getElementById("progressbarGifDiv");
            progressbarGif.style.display = "";
        }else{
            var logoDiv = document.getElementById("logoDiv");
            logoDiv.style.display = "";
            playPorgressBar(1.0,12000);
        }
    }

    function playPorgressBar(progress,duration){
        bar.animate(progress, {duration: duration}, function() {
            console.log("playPorgressBarComplete");
            bar.set(0);
            playPorgressBar(progress,duration);
        });
    }

    window["closeLoadingView"] = function closeLoadingView() {
        
        bar.destroy();
        var bgimg = document.getElementById("bgimg");
        if (bgimg) {
            bgimg.style.backgroundImage = ""
            bgimg.remove();
        }
        var logoDiv = document.getElementById("logoDiv");
        if (logoDiv) {
            logoDiv.remove();
        }
        
        var gifDiv = document.getElementById("progressbarGifDiv");
        if (gifDiv) {
            gifDiv.remove();
        }
        var gif = document.getElementById("progressbarGif");
        if (gif) {
            gif.remove();
        }
        
        delete window["closeLoadingView"];
    }

    function xhrError(){
        if (window.confirm('网络异常，确认后重连！')) {
            window.location.reload();
            return true;
        } else {
            window.location.reload();
            return false;
        }
    }

    function xhrSend(url, callback:(xhr:XMLHttpRequest)=>void,isAutoAlertError = true,method="GET") {
        var xhr = new XMLHttpRequest();
        xhr.open(method, url, true);
        xhr.addEventListener("load", function () {
            callback(xhr);
        });
        xhr.addEventListener('error', function () {
            console.log("error xhr url:"+url);
            if(isAutoAlertError){
                xhrError();
            }else{
                callback(null);
            }     
        }, false);
        xhr.send();
    }

    function loadVersion(versioncode,packagename){
        return new Promise((resolve, reject) => {
            let versionNum = parseInt(versioncode.split(".")[0]);
            packagename = encodeURIComponent(packagename);
            versioncode = encodeURIComponent(versioncode);
            let url = `${window.gameWebServer.host}version?&channel=${window.gameWebServer.channel}&location=${versionNum}&packagename=${packagename}&versioncode=${versioncode}&openid=`;
            xhrSend(url,(xhr)=>{
                if(xhr == null){
                    resolve(xhr);
                    return;
                }
                let jsonObj = JSON.parse(xhr.response);
                resolve(jsonObj);
            },false);
        });
    
    }


    function loadSingleScript(src, callback?) {
        return new Promise((resolve, reject) => {
            var s = document.createElement('script') as HTMLScriptElement;
            s.async = true;
            s.src = src;
            s.addEventListener('load', function () {
                s.parentNode.removeChild(s);
                s.removeEventListener('load', arguments.callee, false);
                if(callback)callback();
                console.log("loadSingleScript:"+src);
                resolve();
            }, false);
            s.addEventListener('error', function () {
                xhrError();
            }, false);
            
            document.body.appendChild(s);
        });
    };

    function loadManifest(gameurl){

        return new Promise((resolve, reject) => {

            xhrSend(gameurl + 'manifest.json?v=' + (new Date()).getTime(),(xhr) => {
                var manifest = JSON.parse(xhr.response);
                if (manifest.gameVersion) {
                    window.gameVersion = manifest.gameVersion;
                }
                var gameList:string[] = [];
                for (var i = 0; i < manifest.game.length; i++) {
                    var key = manifest.game[i];
                    if (key.indexOf("js/PfCommon_") != -1) {
                        continue;
                    }
                    if (key.indexOf("js/promise") != -1) {
                        continue;
                    }
                    gameList.push(key);
                }
                var list = manifest.initial.concat(gameList);
                resolve(list);      
            });
        });
    }

    function localFile(url:string){
        return new Promise((resolve, reject) => {
            let jsPath = cordova.file.applicationDirectory + '/www/' + url;
            window.resolveLocalFileSystemURL(jsPath, file=>{
                resolve(url);
            },()=>{resolve(window.gameClientHost + "/" + url)});
        });
    }


    function runEgret(){
        cordova.plugins.GSystemUtils.checkConnect("", function (res) { console.log("checkConnect: " + res); })
        /**
        * {
        * "renderMode":, //Engine rendering mode, "canvas" or "webgl"
        * "audioType": 0 //Use the audio type, 0: default, 2: web audio, 3: audio
        * "antialias": //Whether the anti-aliasing is enabled in WebGL mode, true: on, false: off, defaults to false
        * "calculateCanvasScaleFactor": //a function return canvas scale factor
        * }
        **/
        egret.runEgret({
            renderMode: "webgl", audioType: 0, calculateCanvasScaleFactor: function (context) {
                var backingStore = context.backingStorePixelRatio ||
                    context.webkitBackingStorePixelRatio ||
                    context.mozBackingStorePixelRatio ||
                    context.msBackingStorePixelRatio ||
                    context.oBackingStorePixelRatio ||
                    context.backingStorePixelRatio || 1;
                return (window.devicePixelRatio || 1) / backingStore;
            }
        });
        console.log("----runEgretSucceed----");
    }

    let oneLoadErrorCount = 0;
    async function run(){
        if(oneLoadErrorCount>4){
            xhrError();
            return;
        }
        let packageName = await cordova.getAppVersion.getPackageName()
        let versioncode = await cordova.getAppVersion.getVersionNumber(); 
        let data = await loadVersion(versioncode,packageName);
        if(data == null){
            setTimeout(() => {
                run();
                oneLoadErrorCount++;
            }, 2000);
            return;
        }
        if(window.gameClientHost == ""){
            window.gameClientHost = data.content.cdns;
            if(data.content.cdns.indexOf("iosreview")!==-1){
                window.gameWebServer.IsAudit = true;
            }
        }
        if(window.gameClientHost.indexOf("baidu.com")!=-1){
            window.gameClientHost = "https://yys37wan-runtime-test-1251923141.file.myqcloud.com/";
        }
        startPorgressBar();
        let manifestList = await loadManifest(window.gameClientHost) as string[];
        for (var i = 0; i < manifestList.length; i++) {
            let jsPath = await localFile(manifestList[i]);
            await loadSingleScript(jsPath);
        }
        await runEgret();
    }
    
    run();

}
